#!/bin/sh

if [ "$1" = "" ]; then
	echo "Usage: BPMMigrateCluster <backupDir> <cluster> <target deployment manager profile name>"
	exit
fi 

if [ "$1" = "-help" ]; then
	echo "Usage: BPMMigrateCluster <backupDir> <cluster> <target deployment manager profile name>"
	exit
fi 

if [ ! -d "$1" ]; then
	echo "Backup directory does not exist."
	exit
fi

if [ "$2" = "" ]; then
	echo "Cluster name and profile name not specified." 
	echo "Usage: BPMMigrateCluster $1 <cluster> <target deployment manager profile name>"
	exit
fi

if [ "$3" = "" ]; then
	echo "Profile name not specified." 
	echo "Usage: BPMMigrateCluster $1 $2 <target deployment manager profile name>"
	exit
fi

MIGRATION_DIR="$1"
CLUSTER="$2"
PROFILE_NAME="$3"

WAS_USER_SCRIPT=""
USER_INSTALL_ROOT=""

binDir=`dirname "$0"`
. "$binDir"/setupCmdLine.sh -profileName "$3"

if [ "$USER_INSTALL_ROOT" = "" ]; then
      echo "Profile name ${PROFILE_NAME} specified is incorrect. Please specify a valid profile name for target deployment manager"
      echo "Usage: BPMMigrateCluster "${MIGRATION_DIR}" "${CLUSTER}" <target deployment manager profile name>"
      exit
fi

echo "Profile location is $USER_INSTALL_ROOT"
echo "Install location is $WAS_HOME"

"$USER_INSTALL_ROOT/bin/ws_ant.sh" -file "$WAS_HOME/util/BPMProfileUpgrade.ant" -DmigrationDir="${MIGRATION_DIR}" -Dcluster="${CLUSTER}"
