@echo off

if [%1] == [] goto invalidUsage

if [%1] == [-help] goto usage

if not exist %1 goto invalidDir

if [%2] == [] goto invalidUsageProfile
if [%3] == [] goto invalidUsageSnapshot

if not exist %3\profiles\%2 mkdir %3\profiles\%2

echo parameters are %1 %2 %3

set WAS_USER_SCRIPT=
set USER_INSTALL_ROOT=

call "%~dp0setupCmdLine.bat"

set CURR_WAS_HOME="%WAS_HOME%"

echo %CURR_WAS_HOME%

set WAS_USER_SCRIPT=
set USER_INSTALL_ROOT=

set SOURCEINSTALLDIR=%1
set SOURCEINSTALLDIR=%SOURCEINSTALLDIR:"=%
echo %SOURCEINSTALLDIR%

call "%SOURCEINSTALLDIR%\bin\setupCmdLine.bat" -profileName "%2"

if "%USER_INSTALL_ROOT%" == "" goto invalidProfile

echo Source Profile location is "%USER_INSTALL_ROOT%"

echo Install location is "%WAS_HOME%"

set BACKUPDIR=%3
set BACKUPDIR=%BACKUPDIR:\=/%
set BACKUPDIR=%BACKUPDIR:"=%
echo %BACKUPDIR%

echo Executing command "%USER_INSTALL_ROOT%"\bin\wsadmin -conntype NONE -lang jython -f %CURR_WAS_HOME%\util\upgrade\BPMQueryDeploymentConfiguration.py -snapshotDir "%BACKUPDIR%" -sourceProfileName %2

for /f "tokens=1-4 delims=/ " %%I in ("%date%") do set mydate=%%J-%%K-%%L
for /f "tokens=1-4 delims=: " %%I in ("%time%") do set mytime=%%I-%%J-%%K
set LOGFILENAME="%3"\logs\BPMQueryDeploymentConfiguration.%mydate%.%mytime%.log

REM check if the logs directory exists - create if it doesn't
IF EXIST "%3"\logs\nul goto END	
	MKDIR "%3"\logs
:END

echo Please check the log file for any error messages. The log file is %LOGFILENAME%

"%USER_INSTALL_ROOT%"\bin\wsadmin -conntype NONE -lang jython -f %CURR_WAS_HOME%\util\upgrade\BPMQueryDeploymentConfiguration.py -snapshotDir "%BACKUPDIR%" -sourceProfileName %2 > "%LOGFILENAME%" 2>&1

set WAS_USER_SCRIPT=
set USER_INSTALL_ROOT=

goto end

:invalidDir
echo Source install Directory %1 does not exist. Please specify a valid source install directory.
goto end

:invalidUsage
echo Usage: BPMSourceApplicationInformation ^<source install root^>  ^<source profile name^> ^<snapshot directory^>
goto end

:usage
echo Usage: BPMSourceApplicationInformation ^<source install root^> ^<source profile name^> ^<snapshot directory^>
goto end

:invalidUsageProfile
echo Source profile name and snapshot directory not specified. 
echo Usage: BPMSourceApplicationInformation %1 ^<source profile name^> ^<snapshot directory^>
goto end

:invalidUsageSnapshot
echo Snapshot directory not specified. 
echo Usage: BPMSourceApplicationInformation %1 %2 ^<snapshot directory^>
goto end

:invalidProfile
echo Profile name %2 specified is incorrect. Please specify the correct source profile name. 
echo Usage: BPMSourceApplicationInformation %1 ^<source profile name^> %3

:end
