# BEGIN COPYRIGHT
# *************************************************************************
# Licensed Materials - Property of IBM 
# 5724-L01, 5655-N53, 5724-I82, 5655-R15
# Copyright IBM Corporation 2009,2010. All rights reserved. 
# US Government Users Restricted Rights - Use, duplication, or disclosure
# restricted by GSA ADP Schedule Contract with IBM Corp.
# *************************************************************************
# END COPYRIGHT
import sys
#import xml.dom.minidom
from javax.xml.parsers import *;
from java.lang import *;
from java.io import *;
from org.apache.xml.serialize import *;


#------------------------------------------------------------------------------
# a utility method
#------------------------------------------------------------------------------
def wsadminToList(inStr):
        outList=[]
        if (len(inStr)>0 and inStr[0]=='[' and inStr[-1]==']'):
                tmpList = inStr[1:-1].split() #splits space-separated lists,
        else:
                tmpList = inStr.split("\n")   #splits for Windows or Linux
        for item in tmpList:
                item = item.rstrip();         #removes any Windows "\r"
                if (len(item)>0):
                        outList.append(item)
        return outList
#endDef

#Adds adapter information for cluster and nodes to
# the xml document. This method could not be used
# for applications since the way the modules are
# scanned for RA are a bit different
#root node for document, main node for applications, clusters or nodes,
#node in config tree, type could be applications, clusters or nodes, appName
#passed only for application scenario
def addAdapterInformation(doc, nodes, node, type, appName):
	if (appName != ""):
		adapter = AdminConfig.showAttribute(node, "resourceAdapter")
		print "Adapter info is ", adapter
		addAdapter(doc, nodes, node, type, appName, adapter)
	else:	
		adapterList = wsadminToList(AdminConfig.list("J2CResourceAdapter", node ))
		print "Adapter list ", adapterList
		for adapter in adapterList:
			#check if for the node the adapter is configured on the cluster
			#we do not show those adapters at node level. They would show at cluster scope
			#if (checkAdapterForCluster(type, adapter) != 0):
				#continue
			addAdapter(doc, nodes, node, type, appName, adapter)
		#endFor	
	#endIf
	

#checks if the node adapter is configured at the cluster scope
#we will do this by compairing the URIs
def checkAdapterForCluster(type, adapter):
	if (type != "node"):
		return 0
	uri = AdminConfig.showAttribute(adapter, "archivePath")
	clusterList = wsadminToList(AdminConfig.list("ServerCluster"))
	for cluster in clusterList:
		print "Cluster is ", cluster
		adapterList = wsadminToList(AdminConfig.list("J2CResourceAdapter", cluster ))
		for clusterAdapter in adapterList:
			clusterAdapterURI = AdminConfig.showAttribute(clusterAdapter, "archivePath")
			if (clusterAdapterURI == uri):
				print "Cluster adapter ", clusterAdapter
				print "matches node scope adapter ", adapter
				return 1
			#endIf
		#endFor
	#endFor
	return 0		

	

#rootElement, main root node, config tree node, type of element (Applications, Nodes, Clusters
#appName passed only for applications, adapter node in config tree	
def addAdapter(doc, nodes, node, type, appName, adapter):
	print "addAdapter ", node
	id = ""
	if (appName != ""):
		nodeName = appName
	else:
		nodeName = AdminConfig.showAttribute(node, "name")
		#for some reason the id tag cannot be treated as 
		#string. Work around by splitting it up
		id = String(node)
		idList = id.split("#")
		id = idList[0] + "#" + idList[1]
		print "id is ", id
	#endIf	
	first=0		
	raDeploymentDes = AdminConfig.showAttribute(adapter, "deploymentDescriptor" )
	raAppName = AdminConfig.showAttribute(adapter, "name" )
	raName = AdminConfig.showAttribute(raDeploymentDes, "displayName")
	#see if the check should be based on adapter rar file name
	#print "archive is ", AdminConfig.showAttribute(adapter, "archivePath")
	print "ra name is ", raName
	
	if ( (raName.find("IBM WebSphere Adapter") != -1) or (raName.find("IBM JDBC Adapter") != -1) ):
	            
		if (first==0):
			nodeChild = doc.createElement(type)
			nodes.appendChild(nodeChild)
			name = doc.createElement("name")
			nodeChild.appendChild(name)
			nameText = doc.createTextNode(nodeName)
			name.appendChild(nameText)
			if (id != ""):
				nodeid = doc.createElement("id")
				nodeChild.appendChild(nodeid)
				idText=doc.createTextNode(id)
				nodeid.appendChild(idText)
			#endIf
			first=1
		#endIf

		#print "Adapter is --------------------", AdminConfig.showall(adapter)
		#print "details ********************", AdminConfig.showall(raDeploymentDes)
		#print "vendor is ", AdminConfig.showAttribute(raDeploymentDes, "vendorName")
		#print "displayName is ", AdminConfig.showAttribute(raDeploymentDes, "displayName")
		print "deployment descriptor ", raDeploymentDes
		raVersion = AdminConfig.showAttribute(raDeploymentDes, "version" )
		raUri = AdminConfig.showAttribute(adapter, "archivePath")
		print "Name is ", raName
		print "Version is ", raVersion
		stringValueDes = String(raDeploymentDes)
		print "string value for Des", stringValueDes
		stringList = stringValueDes.split('#')
		raID = stringList[0] + "#" + stringList[1]
		#raID = stringVal.split(')')[0]
		print "Connector tag ", raID
		
		if (raVersion.find("6.0.2") != -1):
			if (raName.find("SAP") != -1):
				print "WebSphere Adapter for SAP version 6.0.2.x cannot be updated to version 7.0.x during runtime migration."
				print "Please uninstall any applications using WebSphere Adapter for SAP version 6.0.2.x, update them using"
				print "WebSphere Integration Developer and reinstall the applications and adapter post runtime migration."
				print "For more information please refer to \"Runtime premigration checklist\" under \"Migration Overview\" on Information Center"
				sys.exit(1)
			#endIf
		#endIf
		

		if (raVersion.find("6.0.2") != -1):
			comment = doc.createComment("6.0.2 Versions of WebShere Adapters are not supported on 7.0.x WebSphere Process Server.")
			nodeChild.appendChild(comment)
			comment = doc.createComment("The Websphere Adapter instance should be updated to version 7.0.x during runtime migration.")
			nodeChild.appendChild(comment)
			comment = doc.createComment("Please edit the update property below to true and provide the corresponding version 7.0.x RAR file under INSTALL_ROOT/installableApps directory.")
			nodeChild.appendChild(comment)
			comment = doc.createComment("For more information please refer to \"Runtime premigration checklist\" under \"Migration Overview\" on Information Center")
			nodeChild.appendChild(comment)
		#endIf

		if (raName.find("SAP") != -1):
			comment = doc.createComment("Versions 6.0.2.x, 6.1.x and 6.2.x of WebShere Adapter for SAP are not supported on 7.0.x WebSphere Process Server.")
			nodeChild.appendChild(comment)
			comment = doc.createComment("The Websphere Adapter instance should be updated to version 7.0.x during runtime migration.")
			nodeChild.appendChild(comment)
			comment = doc.createComment("Please edit the update property below to true and provide the corresponding version 7.0.x RAR file under INSTALL_ROOT/installableApps directory.")
			nodeChild.appendChild(comment)
			comment = doc.createComment("Please copy the needed SAP application library files for JDK 1.6 under INSTALL_ROOT/bin and INSTALL_ROOT/lib folder as explained on Information Center")
			nodeChild.appendChild(comment)
			comment = doc.createComment("For more information please refer to \"Runtime premigration checklist\" under \"Migration Overview\" on Information Center")
			nodeChild.appendChild(comment)
		#endIf

					
		#add Adapter 
		adapterNode = doc.createElement("adapter")
		nodeChild.appendChild(adapterNode)

		#add Adapter display name
		adapterName = doc.createElement("name")
		adapterNode.appendChild(adapterName)
		adapterNameText = doc.createTextNode(raAppName)
		adapterName.appendChild(adapterNameText)

			
		#add Adapter display name
		adapterName = doc.createElement("displayName")
		adapterNode.appendChild(adapterName)
		adapterNameText = doc.createTextNode(raName)
		adapterName.appendChild(adapterNameText)
				
		#add Adapter version
		adapterVersion = doc.createElement("version")
		adapterNode.appendChild(adapterVersion)
		adapterVersionText = doc.createTextNode(raVersion)
		adapterVersion.appendChild(adapterVersionText)
		
		#add ArchivePath
		adapterURI = doc.createElement("uri")
		adapterNode.appendChild(adapterURI)
		adapterURIText = doc.createTextNode(raUri)
		adapterURI.appendChild(adapterURIText)
				
		#add Deployment ID
		adapterID = doc.createElement("deploymentId")
		adapterNode.appendChild(adapterID)
		adapterIDText = doc.createTextNode(raID)
		adapterID.appendChild(adapterIDText)

		#add migration flag
		update = doc.createElement("update")
		adapterNode.appendChild(update)
		updateText = doc.createTextNode("false")
		update.appendChild(updateText)
	#endIf


def listNodes(doc, nodes):
	print "Entering listNodes"
	if (isDmgrNode() != "False"):
		return
	# This method is called only on custom profiles which only have one node
	node = AdminConfig.getid("/Node:" + System.getProperty("local.node"));
	print "Node is ", node
	addAdapterInformation(doc, nodes, node, "node", "")			
#endDef			
		
def listClusters(doc, clusters):
	print "Entering listClusters"
	#process only if its deployment manager
	if (isDmgrNode() != "True"):
		return
	clusterList = wsadminToList(AdminConfig.list("ServerCluster"))
	for cluster in clusterList:
		print "Cluster is ", cluster
		addAdapterInformation(doc, clusters, cluster, "cluster", "")
	#endFor			
#endDef
	
def getCellType():
	print ""
	cellType = ""
	try:
		print "getting cellID"
		cellID = AdminConfig.getid("/Cell:" + System.getProperty("local.cell"));
		print "cellID : ", cellID 
		
		print "getting cell type"
		cellType = AdminConfig.showAttribute(cellID, 'cellType');
		print "cellType :", cellType
	except:
		print "Unable to get cell type - exception: ", sys.exc_type, sys.exc_value
	
	return cellType
#endDef

def isDmgrNode():
	print ""
	isDmgrNode = "False"
	try:
		nodeNameParam = '[-nodeName ' + System.getProperty("local.node") + ']'
		
		print nodeNameParam
		servers = AdminTask.listServers(nodeNameParam).split(System.getProperty("line.separator"));
		print "servers ", servers
		
		for x in servers:
			servertype = AdminConfig.showAttribute(x, "serverType");
			print "servertype is ", servertype 
			if (servertype == "DEPLOYMENT_MANAGER"):
				isDmgrNode = "True"
				break;
			
			
		
	except:	
		print 'unable to find node type: ', sys.exc_type, sys.exc_value
		
	print "isDmgrNode is", isDmgrNode	
	print ""
	return isDmgrNode				
#endDef	

# list applications installed on specified cell
#------------------------------------------------------------------------------
def listApplications(doc, applications):
	print "Entering listApplications"
	deployments = wsadminToList(AdminConfig.list("Deployment"))
	#print "deployments = ", deployments
	cellType = getCellType()
	isDmgr = isDmgrNode()	
	nodeName = System.getProperty("local.node")
	print "Node name is ", nodeName

	for deployment in deployments:
		appName = deployment.split('(')[0]
		print "-------------appname = " + appName
		processApp = "True"
		if (cellType == "DISTRIBUTED"):
			depTarget = AdminConfig.showAttribute(deployment, "deploymentTargets")
			depTargets = depTarget.split("[")
			print depTargets
			for dep in depTargets:
				if (dep == ""):
					continue
				childDeps = dep.split("]")
				for childDep in childDeps:
					if (childDep == ""):
						continue
					deploymentChild = String(childDep)
					idList = deploymentChild.split("#")
					#for deployment manager process only cluster scoped apps
					if (idList[1].find("ClusteredTarget") != -1):
						print "found cluster scope"
						if (isDmgr != "True"):
							processApp = "False"

					#For standalone and federated nodes only node scoped apps
					if (idList[1].find("ServerTarget") != -1):
						print "found server scope"
						if (isDmgr != "False"):
							processApp = "False"
						else:
							print "node name is ", AdminConfig.showAttribute(childDep, "nodeName")
							if (nodeName != AdminConfig.showAttribute(childDep, "nodeName")):
								processApp = "False"
						#endElse
		print "process App", processApp
		if (processApp != "True"):
			continue
		depObject = AdminConfig.showAttribute(deployment, "deployedObject")
		print "depObject = " + depObject
		modules = wsadminToList(AdminConfig.list("ConnectorModuleDeployment", depObject))
		#print "++++++++++++modules = " , modules
		for module in modules:
			print "checking resource adapter " + module
			addAdapterInformation(doc, applications, module, "application", appName)
	#endFor	
	print "Exiting listApplications"

#------------------------------------------------------------------------------
#main
print "In main BPMQueryDeploymentConfiguration.py"
#extract the value of snapshot directory from arguments
# extract arguments
snapshotDir = ""
profileName = ""
i = 0  #forStart
while ( i < len(sys.argv) ):  #forTest
	arg = sys.argv[i]
	if (arg == "-snapshotDir"):
		i = i+1
		arg = sys.argv[i]
		snapshotDir = arg
	#endIf
	if (arg == "-sourceProfileName"):
		i = i+1
		arg = sys.argv[i]
		profileName = arg
	#endIf
	i = i+1
#endWhile

fileLocation = snapshotDir + File.separator + "profiles" + File.separator + profileName + File.separator + "ApplicationMigrationInformation.xml" 
print "File location is ", fileLocation
#file = open(fileLocation, 'w')
writer = FileWriter(fileLocation)
#doc = xml.dom.minidom.Document()
docFactory = DocumentBuilderFactory.newInstance()
docBuilder = docFactory.newDocumentBuilder()
doc = docBuilder.newDocument()

deploymentInformation = doc.createElement("mig:deploymentInformation")
deploymentInformation.setAttribute("xmlns:mig", "http://www.ibm.com/websphere/processserver/migration")
deploymentInformation.setAttribute("xmlns:xsi", "http://www.w3.org/2001/XMLSchema-instance")
deploymentInformation.setAttribute("xmlns:schemaLocation", "ApplicationMigrationInformation.xsd")

applications = doc.createElement("applications")
nodes = doc.createElement("nodes")
clusters = doc.createElement("clusters")
doc.appendChild(deploymentInformation)
deploymentInformation.appendChild(applications)
deploymentInformation.appendChild(nodes)
deploymentInformation.appendChild(clusters)

applicationInfo = listApplications(doc, applications)
nodeInfo = listNodes(doc, nodes)
clusterInfo = listClusters(doc, clusters)

format = OutputFormat(doc, OutputFormat.Defaults.Encoding, 1)
serializer = XMLSerializer(writer, format)
serializer.serialize(doc)
#xml.dom.ext.PrettyPrint(doc, file)
#file.close()
print "Script completed successfully"
AdminConfig.save()

