# BEGIN COPYRIGHT
# *************************************************************************
# Licensed Materials - Property of IBM 
# 5724-L01, 5655-N53, 5724-I82, 5655-R15
# Copyright IBM Corporation 2009,2010. All rights reserved. 
# US Government Users Restricted Rights - Use, duplication, or disclosure
# restricted by GSA ADP Schedule Contract with IBM Corp.
# *************************************************************************
# END COPYRIGHT
import os.path
import sys
import xml.dom.javadom
from java.lang import *;
from java.io import File;
from xml.dom.javadom import Node


def processChildNodes(doc):
	print "node is ", doc
	for node in doc.childNodes:
		print "node type ", node.nodeType
		print "node name ", node.nodeName
		if (node.nodeType == 1 and node.nodeName == "applications"):
			applications = processNode(node)
			System.setProperty("ApplicationMetadata", applications)
		if (node.nodeType == 1 and node.nodeName == "nodes"):
			nodes = processNode(node)
			System.setProperty("NodeMetadata", nodes)
		if (node.nodeType == 1 and node.nodeName == "clusters"):
			clusters = processNode(node)
			System.setProperty("ClusterMetadata", clusters)
	#endFor	
	
def processNode(nodes):
	applications = ""
	for node in nodes.childNodes:
		print "node type ", node.nodeType
		print "node name ", node.nodeName
		if (node.nodeType == 1 and (node.nodeName == "application" or node.nodeName == "node" or node.nodeName == "cluster")):
			appName = ""
			adapters = ""
			id = ""
			for childNode in node.childNodes:
				print "childNode ", childNode.nodeType
				print "childNode ", childNode.nodeName
				if (childNode.nodeType == 1 and childNode.nodeName == "name"):
					appName = childNode.firstChild.data
				if (childNode.nodeType == 1 and childNode.nodeName == "id"):
					id = childNode.firstChild.data
				if (childNode.nodeType == 1 and childNode.nodeName == "adapter"):
					adapterName = ""
					adapterAppName = ""
					adapterVersion = ""
					updateFlag = ""
					adapterURI = ""
					adapterId = ""
					for adapterNode in childNode.childNodes:
						print "adapter Node ", adapterNode.nodeName
						print "adapter Node ", adapterNode.nodeType
						if (adapterNode.nodeType == 1 and adapterNode.nodeName == "name"):
							adapterAppName = adapterNode.firstChild.data
						if (adapterNode.nodeType == 1 and adapterNode.nodeName == "displayName"):
							adapterName = adapterNode.firstChild.data
						if (adapterNode.nodeType == 1 and adapterNode.nodeName == "version"):
							adapterVersion = adapterNode.firstChild.data						
						if (adapterNode.nodeType == 1 and adapterNode.nodeName == "uri"):
							adapterURI = adapterNode.firstChild.data						
						if (adapterNode.nodeType == 1 and adapterNode.nodeName == "deploymentId"):
							adapterId = adapterNode.firstChild.data						
						if (adapterNode.nodeType == 1 and adapterNode.nodeName == "update"):
							updateFlag = adapterNode.firstChild.data
					#endFor
					adapters = adapters + "[" + adapterAppName + "," + adapterName + "," + adapterVersion + "," + adapterURI + "," + adapterId + "," + updateFlag + "]"
				#endIf
			if (id != ""):
				applications = applications + "[" + appName + "," + id + "," + adapters + "]"
			else:
				applications = applications + "[" + appName + "," +  adapters + "]"
			#endFor
		#endIf
	print "list is", applications
	return applications
	#endFor												

def processApplicationInformation():
	impl = xml.dom.javadom.XercesDomImplementation()
	backupDir = System.getProperty("bpm.upgrade.backup.dir")
	profileName = System.getProperty("bpm.upgrade.previous.profileName")

	if (profileName):
		print "Profile name specified"
	else:
		#find the name from properties file
		userRoot = System.getProperty("user.install.root")
		file = open(userRoot + File.separator + "temp" + File.separator + "bpm_migration.properties.success")
		print "reading the properties file"
		for line in file.readlines():
			print line
			if (line.find("SourceProfileName") != -1):
				#find the name
				list = line.split("=")
				print list[1]
				profileName = list[1].strip()
			#endIf
		#endFor
	#endElse
			
	print "Snapshot location ", backupDir
	print "profile name ", profileName
	if (os.path.exists(backupDir + File.separator + "profiles" + File.separator + profileName + File.separator + "ApplicationMigrationInformation.xml")):
		doc = impl.buildDocumentFile(backupDir + File.separator + "profiles" + File.separator + profileName + File.separator + "ApplicationMigrationInformation.xml")
		processChildNodes(doc.firstChild)
	else:
		print "The file <snapshot directory>/profiles/<profile name>/ApplicationMigrationInformation.xml is not found. Not processing properties for application configuration."
	

#------------------------------------------------------------------------------
#main
print "In main Reading the file"
#System.setProperty("bpm.upgrade.backup.dir", "c:/backup")
processApplicationInformation()
print "Application Metadata ", System.getProperty("ApplicationMetadata")
print "NodeMetadata", System.getProperty("NodeMetadata")
print "ClusterMetadata", System.getProperty("ClusterMetadata")
#---------------------------------------------------------------------------