# BEGIN COPYRIGHT
# *************************************************************************
# Licensed Materials - Property of IBM 
# 5724-L01, 5655-N53, 5724-I82, 5655-R15
# Copyright IBM Corporation 2009,2010. All rights reserved. 
# US Government Users Restricted Rights - Use, duplication, or disclosure
# restricted by GSA ADP Schedule Contract with IBM Corp.
# *************************************************************************
# END COPYRIGHT
#import os.path
import sys
#import xml.dom.javadom
from java.lang import *;
from java.io import File;
#from xml.dom.javadom import Node
from javax.xml.parsers import *;


def getObjectArray(value):
	objectArray = [];
	# @todo: do we have a space problem here?
	stringValue = String(value);
	if (stringValue.length() != 0):
		objectArray = value.split(lineSeparator);
	return objectArray;
#endDef

def processChildNodes(doc):
	print "node is ", doc
	failTheScenario = ""
	nodeList = doc.getChildNodes()
	length = nodeList.getLength()
	i=0
	while (i < length):
		node = nodeList.item(i)
		#print "node type ", node.getNodeType()
		#print "node name ", node.getNodeName()
		if (node.getNodeType() == 1):
			if (node.getNodeName() != "applications" and node.getNodeName() != "nodes" and node.getNodeName() != "clusters"):
				print "ERROR*************************: The root supported root nodes are applications, nodes and clusters. Found invalid root node " + node.getNodeName()
			if (processNode(node) != ""):
				failTheScenario = "true"
				#print "Value is ", failTheScenario
		i=i+1
	#endWhile
	if (failTheScenario != ""):
		sys.exit(1)
	
def processNode(nodes):
	print "Entering processNode"
	applications = ""
	failTheScenario = ""
	nodeList = nodes.getChildNodes()
	length = nodeList.getLength()
	i=0
	while (i < length):
		node = nodeList.item(i)
		#print "node type ", node.getNodeType()
		#print "node name ", node.getNodeName()
		if (node.getNodeType() == 1 and node.getNodeName() != "application" and node.getNodeName() != "node" and node.getNodeName() != "cluster"):
			print "ERROR***************************: Could not find correct child nodes for ", nodes
			print "The applications node should contain a child for application. The nodes node should contain a child for node and the clusters node should contain a child for cluster"
			sys.exit(1)
		if (node.getNodeType() == 1 and (node.getNodeName() == "application" or node.getNodeName() == "node" or node.getNodeName() == "cluster")):
			applications = "true"
			appName = ""
			validNode=""
			adapter=""
			childNodeList = node.getChildNodes()
			childLength = childNodeList.getLength()
			j=0

			while (j < childLength):
				childNode = childNodeList.item(j)
				if (childNode.getNodeType() == 1 and childNode.getNodeName() == "name"):
					appName = childNode.getFirstChild().getNodeValue().strip()
					if (remote != "true"):
						validNode = validateNodeProperties(appName, node.getNodeName())
				if (childNode.getNodeType() == 1 and childNode.getNodeName() == "adapter"):
					adapter = "true"
					adapterName = ""
					adapterVersion = ""
					updateFlag = ""
					adapterURI = ""
					adapterNodeList = childNode.getChildNodes()
					adapterLength = adapterNodeList.getLength()
					k=0

					while (k < adapterLength):
						adapterNode = adapterNodeList.item(k)					
						if (adapterNode.getNodeType() == 1 and adapterNode.getNodeName() == "displayName"):
							adapterName = adapterNode.getFirstChild().getNodeValue().strip()
						if (adapterNode.getNodeType() == 1 and adapterNode.getNodeName() == "version"):
							adapterVersion = adapterNode.getFirstChild().getNodeValue().strip()
						if (adapterNode.getNodeType() == 1 and adapterNode.getNodeName() == "uri"):
							adapterURI = adapterNode.getFirstChild().getNodeValue().strip()
						if (adapterNode.getNodeType() == 1 and adapterNode.getNodeName() == "update"):
							updateFlag = adapterNode.getFirstChild().getNodeValue().strip()
							validateFlag(updateFlag)
						k=k+1
					#endWhile for Adapter
					if (adapterName == "" or adapterVersion == "" or adapterURI == "" or updateFlag == ""):
						print "ERROR***************************: Could not find complete adapter information for " + appName + ". Please specify name, version, uri and update flag properties"
						sys.exit(1)
					#fail for 602 and SAP adapters if the flag is not set to true
					if (adapterVersion.find("6.0.2") != -1 and updateFlag != "true"):
						print "ERROR*********************: Found " + adapterName + " version " + adapterVersion + " for " + appName + ". WebSphere Adapters version 6.0.2.x "
						print "are not supported on Websphere Process Server 7.0."
						print "Please change the update property value to true to update the adapter to version 7.0. Please refer to Information Center section Migrating for more information"
						failTheScenario = "True"
						j=j+1
						continue
					if (adapterURI.find("SAP") != -1 and updateFlag != "true"):
						print "ERROR***********************: Found " + adapterName + " version " + adapterVersion + " for " + appName + ". Websphere Adapter for SAP 6.0.2.x, 6.1.x, 6.2.x "
						print "are not supported on Websphere Process Server 7.0."
						print "Please change the update property value to true to update the adapter to version 7.0. Please refer to Information Center section Migrating for more information"
						failTheScenario = "True"
						j=j+1
						continue
					
					#check for the new RAR file
					if (updateFlag == "true"):
						rarFileName = getRARFileName(adapterName)
						if (rarFileName == ""):
							print "Could not derive RAR file name"
						else:
							rarFileName = System.getProperty("bpm.upgrade.target.install") + File.separator + "installableApps" + File.separator + rarFileName
							print "RAR file location", rarFileName
							rarFile = File(rarFileName)
							if (rarFile.exists()):
								print "RAR file found in installableApps directory"
							else:
								print "***********************ERROR: Found " + adapterName + " version " + adapterVersion + " for " + appName + " for updating to version 7.0.x. Cannot find the RAR file " 
								print " for the WebSphere Adapter " + adapterURI + ". Please copy the respective RAR file into INSTALL_ROOT/installableApps directory and rerun BPMMigrateProfile."
								failTheScenario = "True"
								j=j+1
								continue

					if (remote != "true"):
						validateAdapterInformation(validNode, node.nodeName, appName, adapterName, adapterVersion, adapterURI)
				#endIf
				j=j+1
			#endFor
			if (appName == ""):
				print "ERROR*********************: Could not find name for " + node.getNodeName()
				sys.exit(1)
		i=i+1
	#endFor
	return failTheScenario	

def getRARFileName(adapterName):
	rarFileName = ""
	if (adapterName.find("Oracle") != -1):
		rarFileName = "CWYOE_OracleEBS.rar"
	#endIf
											
	if (adapterName.find("JDBC") != -1):
		rarFileName = "CWYBC_JDBC.rar"
	#endIf

	if (adapterName.find("SAP Software") != -1):
		rarFileName = "CWYAP_SAPAdapter.rar"
	#endIf

	if (adapterName.find("SAP Software with transaction") != -1):
		rarFileName = "CWYAP_SAPAdapter_Tx.rar"
	#endIf

	if (adapterName.find("Email") != -1):
		rarFileName = "CWYEM_EMail.rar"
	#endIf

	if (adapterName.find("Flat Files") != -1):
		rarFileName = "CWYFF_FlatFile.rar"
	#endIf

	if (adapterName.find("FTP") != -1):
		rarFileName = "CWYFT_FTPFile.rar"
	#endIf

	if (adapterName.find("IBM i") != -1):
		rarFileName = "ios.rar"
	#endIf

	if (adapterName.find("JD Edwards") != -1):
		rarFileName = "CWYED_JDE.rar"
	#endIf

	if (adapterName.find("PeopleSoft") != -1):
		rarFileName = "CWYES_PeopleSoft.rar"
	#endIf

	if (adapterName.find("Siebel") != -1):
		rarFileName = "CWYEB_SiebelAdapter.rar"
	#endIf

	return rarFileName
#endDef

def processApplicationInformation():
	#impl = xml.dom.javadom.XercesDomImplementation()
	backupDir = System.getProperty("bpm.upgrade.backup.dir")
	profileName = System.getProperty("bpm.upgrade.previous.profileName")
	print "Reading file ", backupDir + File.separator + "profiles" + File.separator + profileName + File.separator + "ApplicationMigrationInformation.xml"
	file = File(backupDir + File.separator + "profiles" + File.separator + profileName + File.separator + "ApplicationMigrationInformation.xml")
	#if (os.path.exists(backupDir + File.separator + "profiles" + File.separator + profileName + File.separator + "ApplicationMigrationInformation.xml")):
	if (file.exists()):
		dbf = DocumentBuilderFactory.newInstance();
		db = dbf.newDocumentBuilder();
		doc = db.parse(backupDir + File.separator + "profiles" + File.separator + profileName + File.separator + "ApplicationMigrationInformation.xml");
		#doc = impl.buildDocumentFile(backupDir + File.separator + "profiles" + File.separator + profileName + File.separator + "ApplicationMigrationInformation.xml")
		processChildNodes(doc.getFirstChild())
	else:
		print "The file <snapshot directory>/profiles/<profile name>/ApplicationMigrationInformation.xml is not found. Skipping validation"

#validate the update flag for boolean values
def validateFlag(updateFlag):
	if (updateFlag != "true" and updateFlag != "false"):
		print "ERROR***********************: Cannot process value " + updateFlag + ". The value for update flag can only be true or false."
		sys.exit(1)

#validate the properties for application, node and cluster
def validateNodeProperties(appName, nodeName):
	print "Entering validateNodeProperties"
	if (nodeName == "application"):
		return validateApplication(appName)
	if (nodeName == "node"):
		return validateNode(appName)
	if (nodeName == "cluster"):
		return validateCluster(appName)
#end Def

#validate the adapter information for node, cluster and applications
def validateAdapterInformation(node, nodeName, appName, name, version, uri):
	print "Entering validateAdapterInformation " + name + " " + version + " " + uri
	if (nodeName == "application"):
		modules = getObjectArray(AdminConfig.list("ConnectorModuleDeployment", node))
		#print "++++++++++++modules = " , modules
		
		for module in modules:
			#print "checking resource adapter " + module
			adapter = AdminConfig.showAttribute(module, "resourceAdapter")
			print "Adapter info is ", adapter
			if (validateAdapter(adapter, name, version, uri) == 0):
				return 0
		print "ERROR****************************: Websphere adapter with name " + name + " version " + version + " uri " + uri + "cannot be found under application " + appName
		sys.exit(1)		
	else:	
		adapterList = getObjectArray(AdminConfig.list("J2CResourceAdapter", node ))
		print "Adapter list ", adapterList
		for adapter in adapterList:
			if (validateAdapter(adapter, name, version, uri) == 0):
				return 0
		#endFor	
		print "ERROR****************************: Websphere adapter with name " + name + " version " + version + " uri " + uri + "cannot be found under " + appName
		sys.exit(1)

	#endIf

#validate the adapter information	
def validateAdapter(adapter, name, version, uri):
	print "validateAdapter for " + name + " with ", adapter
	id = ""
	raDeploymentDes = AdminConfig.showAttribute(adapter, "deploymentDescriptor" )
	raName = AdminConfig.showAttribute(raDeploymentDes, "displayName")
	#see if the check should be based on adapter rar file name
	#print "archive is ", AdminConfig.showAttribute(adapter, "archivePath")
	print "ra name is ", raName
	if ( (raName.find("IBM WebSphere Adapter") != -1) or (raName.find("IBM JDBC Adapter") != -1) ):
		#print "Adapter is --------------------", AdminConfig.showall(adapter)
		#print "details ********************", AdminConfig.showall(raDeploymentDes)
		#print "vendor is ", AdminConfig.showAttribute(raDeploymentDes, "vendorName")
		#print "displayName is ", AdminConfig.showAttribute(raDeploymentDes, "displayName")
		print "deployment descriptor ", raDeploymentDes
		raVersion = AdminConfig.showAttribute(raDeploymentDes, "version" )
		raUri = AdminConfig.showAttribute(adapter, "archivePath")
		print "Name is ", raName
		print "Version is ", raVersion
		stringValueDes = String(raDeploymentDes)
		print "string value for Des", stringValueDes
		stringList = stringValueDes.split('#')
		raID = stringList[0] + "#" + stringList[1]
		#raID = stringVal.split(')')[0]
		print "Connector tag ", raID
		if (name == raName and version == raVersion and uri == raUri):
			print "Websphere Adapter found " + raName + " " + raVersion + " " + raUri
			return 0
			
	#endIf
	return 1

#validate node information
def validateNode(name):
	print "Entering validateNode"
	nodeList = getObjectArray(AdminConfig.list("Node"))
	
	for node in nodeList:
		print "Node is ", node
		nodeName = AdminConfig.showAttribute(node, "name")
		if (name == nodeName):
			return node
	#endFor	
	print "ERROR: The node with name " + name + " cannot be found"
	sys.exit(1)		
	
#validate cluster information	
def validateCluster(name):
	print "Entering valiateCluster"
	clusterList = getObjectArray(AdminConfig.list("ServerCluster"))
	for cluster in clusterList:
		print "Cluster is ", cluster
		clusterName = AdminConfig.showAttribute(cluster, "name")
		if (name == clusterName):
			return cluster
	#endFor			
	print "ERROR: The cluster with name " + name + " cannot be found"
	sys.exit(1)		
	

# validate application information installed on specified cell
#------------------------------------------------------------------------------
def validateApplication(name):
	print "Entering validateApplications", name
	deployments = getObjectArray(AdminConfig.list("Deployment"))
	#print "deployments = ", deployments
      
	for deployment in deployments:
		appName = deployment.split('(')[0]
		print "-------------appname = " + appName
		depObject = AdminConfig.showAttribute(deployment, "deployedObject")
		#print "depObject = " + depObject

		if (name == appName):
			return depObject
	#endFor
	print "ERROR*******************************: The application with name " + name + " cannot be found"
	sys.exit(1)	

remote="false"
#------------------------------------------------------------------------------
#main
print "In main Reading the file"
print "lenght is ", len(sys.argv)

snapshotDir = ""
profileName = ""
installRoot = ""

i = 0  #forStart
while ( i < len(sys.argv) ):  #forTest
	arg = sys.argv[i]
	if (arg == "-snapshotDir"):
		i = i+1
		arg = sys.argv[i]
		snapshotDir = arg
	#endIf
	if (arg == "-sourceProfileName"):
		i = i+1
		arg = sys.argv[i]
		profileName = arg
	#endIf
	if (arg == "-targetInstall"):
		i = i+1
		arg = sys.argv[i]
		installRoot = arg
	#endIf

	i = i+1
#endWhile

#snapshotDir = sys.argv[1]
#profileName = sys.argv[3]
#installRoot = sys.argv[5]
#script called with -remote flag so skip validations for
#appName, cluster name, node name etc.
if (len(sys.argv) == 7):
	remote="true"
print "Snapshot directory is", snapshotDir
print "Profile name is", profileName
print "Target install root is", installRoot
System.setProperty("bpm.upgrade.backup.dir", snapshotDir)
System.setProperty("bpm.upgrade.previous.profileName", profileName)
System.setProperty("bpm.upgrade.target.install", installRoot)
processApplicationInformation()
print "ValidateDeploymentConfiguration script completed successfully"
#---------------------------------------------------------------------------

